Description

Cloned from bugzilla https://bugzilla.redhat.com/show_bug.cgi?id=2265062

Description of problem:

Old or incorrect host kernel versions are printed in the generated report.

Multiple services are reporting kernel version facts to the Satellite, such as Ansible, Puppet and RHSM. While resolving the kernel

version for a host, Satellite will pick the first one order by fact type. Since "Ansible" starts with 'A', kernel version reported by Ansible

will normally be picked. If Ansible roles job is not run after the last host kernel update, then old or wrong kernel version will be

reported.

How reproducible:

Easy

Steps to Reproduce:

1. Register a host to the Satellite.

2. Run Ansible roles against the host

3. Update the kernel of the host

Actual results:

Report template generated the old kernel version of the host.

Expected results:

Report template generated the upgraded kernel version of the host.

Additional info:

We can run the following hammer command to query all reported kernel versions of a host.

hammer fact list --search "host = content_host.example.com and (name = kernelrelease or name = ans

ible_kernel or name = kernel::release or name = uname::release)" 

 As we can see in the example below, Ansible fact has the outdated kernel version.

----------------------------|----------------|-----------------------------

HOST                        | FACT           | VALUE

----------------------------|----------------|-----------------------------

content_host.example.com    | ansible_kernel | 3.10.0-1062.4.1.el7.x86_64  <==============

content_host.example.com    | uname::release | 3.10.0-1160.105.1.el7.x86_64

----------------------------|----------------|-----------------------------

 As we can see below, the results are sorted by "fact_names.type" which means Ansible fact type always took precedence over other
fact types.

# /usr/share/foreman/app/models/host/base.rb

module Host

  class Base < ApplicationRecord

    <snip>

    has_one :kernel_release, -> { joins(:fact_name).where({ 'fact_names.name' => KERNEL_RELEASE_FA

CTS }).order('fact_names.type') }, :class_name => '::FactValue', :foreign_key => 'host_id'

Associated revisions

Revision 459f70c4 - 02/26/2024 09:53 AM - Hao Yu

Fixes #37184 - Report template generates incorrect kernel version

History

#1 - 02/20/2024 06:28 AM - Hao Yu

- Description updated

#2 - 02/20/2024 07:19 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Hao Yu

- Pull request https://github.com/theforeman/foreman/pull/10056 added

#3 - 02/26/2024 09:53 AM - The Foreman Bot

- Fixed in Releases 3.11.0 added

#4 - 02/26/2024 10:00 AM - Hao Yu

- Status changed from Ready For Testing to Closed

Applied in changeset foreman|459f70c4f78d75e9948dab437b484319f38fb4aa.

#5 - 03/19/2024 02:18 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/10103 added

#6 - 03/20/2024 06:03 PM - The Foreman Bot

- Fixed in Releases 3.10.0 added
